#include	<stdio.h>
#include	<sys/param.h>
#include	<Xm/DrawingA.h>
#include	<Xm/Text.h>
#include	<Xm/FileSB.h>
#include	<Xm/Frame.h>
#include	<Xm/LabelG.h>
#include	<Xm/MessageB.h>
#include	<Xm/PushB.h>
#include	<Xm/RowColumn.h>
#include	<Xm/Separator.h>
#include	"gene.h"
#include	"draw.h"

extern	FILE	*DataFile;
extern	char	*DataFileName;
extern	Widget	app_sh;
extern	Arg	ShellArgs[];
extern	int	NShellArg;

typedef	enum { FSBNone, FSBOpen, FSBSave } FSBMode;
static	Widget	FSBDialog = NULL;
static	FSBMode	mode = FSBNone;

show_message(msg1,msg2) char *msg1, *msg2;
{
	static	Widget	Dialog = NULL;
	XmString	str;
	char	buf[128];
	if (!Dialog) {
		Dialog = XmCreateMessageDialog(app_sh,"Message",
			ShellArgs,NShellArg);
		XtUnmanageChild(XmMessageBoxGetChild(Dialog,
			XmDIALOG_HELP_BUTTON));
	}
	strcpy(buf,msg1);
	if (msg2) strcat(buf,msg2);
	str = XmStringCreateSimple(buf);
	XtVaSetValues(Dialog,XmNmessageString,str,NULL);
	XmStringFree(str);
	XtManageChild(Dialog);
}

static void unmapCB(w,cl,cd) Widget w; XtPointer cl,cd; { mode = FSBNone; }
static void okCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	FILE	*fd;
	static	char	fname[64];
	String	str =
	XmTextGetString(XmFileSelectionBoxGetChild(w,XmDIALOG_TEXT));
	fd = fopen(str,((mode == FSBOpen)? "r" : "w"));
	if (!fd) { show_message(str," cannot open."); return; }
	if (DataFile) fclose(DataFile);
	strcpy(fname,str);
	XtFree(str);
	DataFile = fd;
	DataFileName = fname;
	if (mode == FSBOpen) b_load();
	else b_save();
	XtUnmanageChild(FSBDialog);
}
void cancelCB(w,cl,cd) Widget w; XtPointer cl,cd; { XtUnmanageChild(w); }
static void create_FSB()
{
	if (FSBDialog) return;
	FSBDialog = XmCreateFileSelectionDialog(app_sh,"FSBDialog",
		ShellArgs,NShellArg);
	XtUnmanageChild(XmFileSelectionBoxGetChild(FSBDialog,
		XmDIALOG_HELP_BUTTON));
	XtAddCallback(FSBDialog,XmNokCallback,okCB,NULL);
	XtAddCallback(FSBDialog,XmNcancelCallback,cancelCB,NULL);
	XtAddCallback(FSBDialog,XmNunmapCallback,unmapCB,NULL);
}
static int open_data_file(mfsb) FSBMode mfsb;
{
	if (mode != FSBNone) return 1;
	create_FSB(); mode = mfsb; XtManageChild(FSBDialog);
	return 0;
}
file_open() { open_data_file(FSBOpen); }
file_save_as() { open_data_file(FSBSave); }
file_load() { if (!DataFile) file_open(); else b_load(); }
file_save() { if (!DataFile) file_save_as(); else b_save(); }

static Widget	PrintCommand = NULL;
static int	printDPI = 72;
static char	PrintPSProlog[] = "%!PS-Adobe-2.0\n";
static char	DeluxPSProlog[] = "90 rotate\n100 -540 translate\n";
static char *PSHeader = "%!PS-Adobe-2.0 EPSF-2.0\n%%BoundingBox: 0 0 ";
static char *PSPrologSphere = "gsave\n\
/C {/g exch def /s exch def\n\
newpath x y r s mul 0 360 arc closepath g setgray fill} def\n\
/S {/r exch def /y exch def /x exch def\n\
 1 0 C .981 .125 C .924 .25 C .831 .375 C .707 .5 C .556 .625 C\n\
 .382 .75 C .195 .875 C} def\n1 1 scale\n";
static char *PSPrologLine = "gsave\n\
/C {newpath 0 360 arc closepath .5 setgray fill} def\n\
/L {/r exch def /y exch def /x exch def\n\
newpath moveto x y lineto 0 setgray stroke x y r C} def\n\
1 1 scale\n2 setlinewidth\n";
static char *PSEpilog = "showpage\ngrestore\n";
extern	DrawingShape	DrawShape;
static FILE	*ImgFD = NULL;
typedef enum { ImageFormPS, ImageFormXWD } ImageForm;
static ImageForm imageForm = ImageFormPS;
extern	int	WindowWidth, WindowHeight;
extern	XtAppContext	app_con;
extern	Display	*dpy;
extern	GC	gc;

static	Widget	ProgreBarDialog = NULL, ProgreBar = NULL;
static	Dimension	ProgreBarWidth, ProgreBarHeight;
static	Pixel	ProgreBarFG, ProgreBarBG;
static	Window	ProgreBarWindow;
static	int	ProgreValue = 0;
static void cancelPrintCB(w,cl,cd) Widget w; XtPointer cl,cd;{ print_cancel(); }
static int create_progress_meter()
{
	Widget	w, frame;
	Arg	args[2];
	w = XmCreateWorkingDialog(app_sh,"ProgressBar",ShellArgs,NShellArg);
	XtUnmanageChild(XmMessageBoxGetChild(w,XmDIALOG_HELP_BUTTON));
	XtUnmanageChild(XmMessageBoxGetChild(w,XmDIALOG_OK_BUTTON));
	XtAddCallback(w,XmNcancelCallback,cancelPrintCB,NULL);
	if (!w) {
		show_message("cannot create dialog",NULL);
		return 1;
	}
	XtSetArg(args[0],XmNshadowType,XmSHADOW_ETCHED_IN);
	XtSetArg(args[1],XmNshadowThickness,4);
	XtManageChild(frame = XmCreateFrame(w,"frame",args,2));
	XtSetArg(args[0],XmNheight,20);
	XtSetArg(args[1],XmNwidth,200);
	XtManageChild(ProgreBar = XmCreateDrawingArea(frame,"draw",args,2));
	ProgreBarDialog = w;
	return 0;
}
progress_meter_start() {
	if (!ProgreBarDialog) if (create_progress_meter()) return 1;
	XtManageChild(ProgreBarDialog);
	XtVaGetValues(ProgreBar,XmNwidth,&ProgreBarWidth,
		XmNheight,&ProgreBarHeight,
		XmNforeground,&ProgreBarFG,XmNbackground,&ProgreBarBG,NULL);
	ProgreBarWindow = XtWindow(ProgreBar);
	ProgreValue = 0;
	XClearWindow(dpy,XtWindow(ProgreBar));
}
progress_meter_close() { XtUnmanageChild(ProgreBarDialog); }
progress_meter_set(a,b) int a,b;
{
	int	ww, hh;
	ww = (int)ProgreBarWidth * a / b;
	if (ww != ProgreValue) {
		hh = ProgreBarHeight;
		XSetForeground(dpy,gc,ProgreBarBG);
		XFillRectangle(dpy,ProgreBarWindow,gc,ww,0,
			(int)ProgreBarWidth - ww,hh);
		XSetForeground(dpy,gc,ProgreBarFG);
		XFillRectangle(dpy,ProgreBarWindow,gc,0,0,ww,hh);
		ProgreValue = ww;
	}
}
static void ps_sphere(c)
Cell	*c;
{
	fprintf(ImgFD,"%.2f %.2f %.2f S\n",c->draw_x,
		WindowHeight-1-c->draw_y,c->draw_r);
}
static void ps_line(c)
Cell	*c;
{
	Cell	*m = c->mother;
	if (m) fprintf(ImgFD,"%.2f %.2f %.2f %.2f %.2f L\n",
		m->draw_x,WindowHeight-1-m->draw_y,
		c->draw_x,WindowHeight-1-c->draw_y,c->draw_r*.25);
	else fprintf(ImgFD,"%.2f %.2f %.2f C\n",
		c->draw_x,WindowHeight-1-c->draw_y,c->draw_r*.25);
}

print_close(pout) FILE *pout; { fputs(PSEpilog,pout); pclose(pout); }
static void dpiCB(w,cl,cd) Widget w; XtPointer cl,cd; { printDPI = (int)cl; }
static Boolean printWP(cl) XtPointer cl;
{
	String	str = XmTextGetString(PrintCommand);
	FILE	*pout = popen(str,"w");
	Boolean	print_one_line();
	if (!pout)
		{ show_message(str," cannot be executed."); return True; }
	fputs(PrintPSProlog,pout);
	switch (DrawShape) {
		case DrSpSkeleton:
		fputs(PSPrologLine, (ImgFD = pout));
		save_image_p(ps_line); break;
		case DrSpSpheres: case DrSpGrowingSpheres:
		fputs(PSPrologSphere, (ImgFD = pout));
		save_image_p(ps_sphere); break;
		case DrSpDeluxe:
		fputs(DeluxPSProlog,pout);
		if (!print_ps_image(pout,printDPI))
			XtAppAddWorkProc(app_con,print_one_line,NULL);
		return True;
	}
	print_close(pout);
	return True;
}
static void printOkCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	XtAppAddWorkProc(app_con,printWP,NULL);
}
static Widget create_print_fsb()
{
	Widget	w, f, b, m;
	Arg	args[2];
	w = XmCreateQuestionDialog(app_sh,"PrintQuery",ShellArgs,NShellArg);
	XtUnmanageChild(XmMessageBoxGetChild(w,XmDIALOG_HELP_BUTTON));
	XtManageChild(f=XmCreateRowColumn(w,"form",NULL,0));
	m = XmCreatePulldownMenu(app_sh,"menu",ShellArgs,NShellArg);
	XtManageChild(b=XmCreatePushButton(m,"72dpi",NULL,0));
	XtAddCallback(b,XmNactivateCallback,dpiCB,(XtPointer)72);
	XtManageChild(b=XmCreatePushButton(m,"150dpi",NULL,0));
	XtAddCallback(b,XmNactivateCallback,dpiCB,(XtPointer)150);
	XtManageChild(b=XmCreatePushButton(m,"300dpi",NULL,0));
	XtAddCallback(b,XmNactivateCallback,dpiCB,(XtPointer)300);
	XtSetArg(args[0],XmNsubMenuId,m);
	XtManageChild(XmCreateOptionMenu(f,"dpi",args,1));
	XtManageChild(XmCreateSeparator(f,"sep1",NULL,0));
	XtManageChild(XmCreateLabelGadget(f,"Print command:",NULL,0));
	XtManageChild(PrintCommand = XmCreateText(f,"command",NULL,0));
	XtAddCallback(w,XmNokCallback,printOkCB,NULL);
	XtAddCallback(w,XmNcancelCallback,cancelCB,NULL);
	return w;
}
image_print() {
	static Widget	FSB = NULL;
	if (!FSB) {
		if (!(FSB = create_print_fsb())) {
			show_message("Cannot create print query box.",NULL);
			return 0;
		}
	}
	XtManageChild(FSB);
}
static void imgOkCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	String	str =
	XmTextGetString(XmFileSelectionBoxGetChild(w,XmDIALOG_TEXT));
	ImgFD = fopen(str,"w");
	if (!ImgFD) { show_message(str," cannot open."); XtFree(str); return; }
	XtFree(str);
	switch (imageForm) {
		case ImageFormPS:
		fprintf(ImgFD,"%s%d %d\n",PSHeader,WindowWidth,WindowHeight);
		switch (DrawShape) {
			case DrSpSkeleton:
			fputs(PSPrologLine,ImgFD);
			save_image_p(ps_line);
			break;
			case DrSpSpheres: case DrSpGrowingSpheres:
			fputs(PSPrologSphere,ImgFD);
			save_image_p(ps_sphere);
			break;
			case DrSpDeluxe:
			save_ps_image(ImgFD);
		}
		fputs(PSEpilog,ImgFD);
		break;
		case ImageFormXWD:
		save_xwd_image(ImgFD);
	}
	fclose(ImgFD);
	XtUnmanageChild(w);
}
static void formatCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	imageForm = (ImageForm)cl;
}
static Widget create_image_fsb()
{
	Widget	w, b, m;
	Arg	args[2];
	w = XmCreateFileSelectionDialog(app_sh,"FSBimage",
		ShellArgs,NShellArg);
	XtUnmanageChild(XmFileSelectionBoxGetChild(w,XmDIALOG_HELP_BUTTON));
	m = XmCreatePulldownMenu(app_sh,"menu",ShellArgs,NShellArg);
	XtManageChild(b=XmCreatePushButton(m,"PostScript",NULL,0));
	XtAddCallback(b,XmNactivateCallback,formatCB,(XtPointer)ImageFormPS);
	XtManageChild(b=XmCreatePushButton(m,"XWD",NULL,0));
	XtAddCallback(b,XmNactivateCallback,formatCB,(XtPointer)ImageFormXWD);
	XtSetArg(args[0],XmNsubMenuId,m);
	XtManageChild(XmCreateOptionMenu(w,"format",args,1));
	XtAddCallback(w,XmNokCallback,imgOkCB,NULL);
	XtAddCallback(w,XmNcancelCallback,cancelCB,NULL);
	return w;
}
image_save() {
	static Widget	FSB = NULL;
	if (!FSB) {
		if (!(FSB = create_image_fsb())) {
			show_message("Cannot create file selection box.",NULL);
			return 0;
		}
	}
	XtManageChild(FSB);
}

int	MovieOn = 0;
int	NFrames = 0;
static	FILE	*MovieFD = NULL;
static void set_button_sens(res,stp,cls) Boolean res, stp, cls; {
	extern	Widget	RestartMovieButton, StopMovieButton, CloseMovieButton;
	XtVaSetValues(RestartMovieButton,XmNsensitive,res,NULL);
	XtVaSetValues(StopMovieButton,XmNsensitive,stp,NULL);
	XtVaSetValues(CloseMovieButton,XmNsensitive,cls,NULL);
}
static void movOkCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	String	fname =
	XmTextGetString(XmFileSelectionBoxGetChild(w,XmDIALOG_TEXT));
	MovieFD = fopen(fname,"w");
	XtFree(fname);
	if (!MovieFD) {
		show_message(fname," cannot open to write.");
		MovieOn = 0;
		set_button_sens(False,False,False);
		return;
	}
	MovieOn = 1;
	set_button_sens(False,True,True);
	qt_init(MovieFD,WindowWidth,WindowHeight);
	save_one_frame(MovieFD);
	NFrames = 1;
	XtUnmanageChild(w);
}
static Widget create_movie_fsb()
{
	Widget	w;
	w = XmCreateFileSelectionDialog(app_sh,"FSBmovie",
		ShellArgs,NShellArg);
	XtUnmanageChild(XmFileSelectionBoxGetChild(w,XmDIALOG_HELP_BUTTON));
	XtAddCallback(w,XmNokCallback,movOkCB,NULL);
	XtAddCallback(w,XmNcancelCallback,cancelCB,NULL);
	return w;
}
movie_new() {
	static Widget	FSB = NULL;
	if (!FSB) { if (!(FSB = create_movie_fsb())) {
		show_message("Cannot create file selection box.",NULL);
		return 0;
	}}
	XtManageChild(FSB);
}
movie_restart() { MovieOn = 1; save_one_frame(MovieFD); NFrames ++; }
movie_stop() { MovieOn = 0; set_button_sens(True,False,True); }
movie_close() {
	MovieOn = 0;
	if (MovieFD) {
		qt_close(NFrames);
		MovieFD = NULL;
		set_button_sens(False,False,False);
	}
}
check_dump_frame() { if (MovieOn) { save_one_frame(MovieFD); NFrames ++; } }
