#include	<stdio.h>
#include	<math.h>
#include	<Xm/MainW.h>
#include	<Xm/DrawingA.h>
#include	<Xm/Form.h>
#include	<Xm/Label.h>
#include	<Xm/PushB.h>
#include	<Xm/RowColumn.h>
#include	<Xm/CascadeB.h>
#include	<Xm/Separator.h>
#include	<Xm/ToggleB.h>
#include	<Xm/Text.h>
#include	<Xm/MessageB.h>
#include	<Xm/Scale.h>
#include	<Xm/Separator.h>
#include	<X11/xpm.h>
#include	"gene.h"
#include	"draw.h"

XtAppContext	app_con;
int	WindowWidth, WindowHeight;
DrawingShape	DrawShape = DrSpSkeleton;
long	DrawPopSize = -1, DrawWhen = 10;
double	RotateX = M_PI/12., RotateY = 0., RotateZ = 0., ScaleR = 1.;
double	ViewDistance = 0., ViewShift = 0., ViewHeight = 0.;
double	RotateXV = 0., RotateYV = M_PI/200., RotateZV = 0.;
double	DistanceV = 0., ScaleRV = 1.;
extern	unsigned long	Step, Generation;
extern	int	GenerationLength;
extern	int	IScale, SeedForRandom;
extern	Boolean	FullScreen, BlackBackground;

Widget	app_sh;
Display *dpy;
Window	window;
Pixmap	pixmap;
GC	gc;
int	depth;
Pixel	fg, bg;
Colormap	cmap;
Visual	visual;
Arg	ShellArgs[6];
int	NShellArg;
XFontStruct	*Gfont;
char	*DataFileName = NULL, *DumpFileName = NULL;
static	Window	WinG, WinS, WinF;
static	Pixel	Winfg, Winbg;
static	int	WinWidth, WinHeight, ShowNBase;
static	Widget	SeedRand, SeedText, CaptionText = NULL;
static	Widget	StopButton, GrowingSpheresButton, DeluxeButton;
Widget	RestartMovieButton, StopMovieButton, CloseMovieButton;
Widget	GenomeGraphButton, EvolutionProcessButton;
typedef	enum { PMRun, PMOneGeneration, PMStep, PMMotion, PMStop } ProgressMode;

static ProgressMode	Running = PMStop;
XtWorkProcId	RunningProcID = 0;
int	DeluxePainting = 0;
void	check_deluxe_draw()
{
	extern	Boolean	draw_one_line();
	if (DeluxePainting == 1) {
		XtAppAddWorkProc(app_con,draw_one_line,NULL);
		DeluxePainting = 2;
	}
}
static void set_pmode(mode) ProgressMode mode; {
	Running = mode;
	XtVaSetValues(StopButton,XmNsensitive,(mode != PMStop),NULL);
}
static Boolean one_step(cl) XtPointer cl;
{
	Boolean	flag;
	flag = exec_one_step();
	switch (Running) {
		case PMRun: if (!flag && !DeluxePainting) selection(); break;
		case PMOneGeneration:
		if (Step >= GenerationLength) set_pmode(PMStop); break;
	}
	flag = ((Running != PMRun && Running != PMOneGeneration)
		|| DeluxePainting);
	if (flag) RunningProcID = 0;
	return flag;
}
static	int	MotionCount = 0, MotionDuration = 100;
static Boolean motion_one_step(cl) XtPointer cl;
{
	int	flag;
	move_view_point();
	redraw_world();
	if ((++ MotionCount) >= MotionDuration) set_pmode(PMStop);
	flag = (Running != PMMotion || DeluxePainting);
	if (flag) RunningProcID = 0;
	return flag;
}
void check_run_selection() {
	if (Running == PMRun && Step == GenerationLength) selection();
}
void start_exec() {
	if ((Running == PMRun || Running == PMOneGeneration) && !RunningProcID)
		RunningProcID = XtAppAddWorkProc(app_con,one_step,NULL);
	else if (Running == PMMotion) {
		RunningProcID = XtAppAddWorkProc(app_con,motion_one_step,NULL);
	}
}
static void progress(mode) ProgressMode mode;
{
	if (Running == PMRun && mode == PMRun) { set_pmode(PMStop); return; }
	if (mode == PMOneGeneration && Step >= GenerationLength) selection();
	set_pmode(mode);
	start_exec();
}
static void set_and_draw_srand()
{
	char	buf[32];
	XmString	str;
	if (!SeedForRandom) { srand48(time(0)); SeedForRandom = lrand48(); }
	srand48(SeedForRandom);
	sprintf(buf,"%d",SeedForRandom);
	str = XmStringCreateSimple(buf);
	XtVaSetValues(SeedRand,XmNlabelString,str,NULL);
}
static void ShowModeCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	if (((XmToggleButtonCallbackStruct *)cd)->set
	 && DrawShape != (DrawingShape)cl) {
		DrawShape = (DrawingShape)cl;
		redraw_world();
	}
}
static void DrawWhatCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	if (((XmToggleButtonCallbackStruct *)cd)->set 
	 && DrawPopSize != (int)cl) {
		DrawPopSize = (int)cl;
		redraw_world();
	}
}
static void DrawWhenCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	if (((XmToggleButtonCallbackStruct *)cd)->set) DrawWhen = (int)cl;
}
static void SelModeCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	extern	SelectionMode	SelMode;
	if (((XmToggleButtonCallbackStruct *)cd)->set)
		SelMode = (SelectionMode)cl;
}
static void CrossoverCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	extern	CrossoverMode	CrossMode;
	if (((XmToggleButtonCallbackStruct *)cd)->set)
		CrossMode = (CrossoverMode)cl;
}
extern	double	MutationRate;
static void MutationCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	XmScaleCallbackStruct *sc = (XmScaleCallbackStruct *)cd;
	MutationRate = sc->value / 1000.;
}
static void OpenCB(w,cl,cd) Widget w; XtPointer cl,cd; { file_open(); }
static void LoadCB(w,cl,cd) Widget w; XtPointer cl,cd; { file_load(); }
static void SaveCB(w,cl,cd) Widget w; XtPointer cl,cd; { file_save(); }
static void SaveAsCB(w,cl,cd) Widget w; XtPointer cl,cd; { file_save_as(); }
static void PrintCB(w,cl,cd) Widget w; XtPointer cl,cd; { image_print(); }
static void SaveImgCB(w,cl,cd) Widget w; XtPointer cl,cd; { image_save(); }
static void StartNewMovieCB(w,cl,cd) Widget w; XtPointer cl,cd; { movie_new(); }
static void RestartMovieCB(w,cl,cd) Widget w; XtPointer cl,cd; { movie_restart(); }
static void StopMovieCB(w,cl,cd) Widget w; XtPointer cl,cd; { movie_stop(); }
static void CloseMovieCB(w,cl,cd) Widget w; XtPointer cl,cd; { movie_close(); }
static void RestartCB(w,cl,cd) Widget w; XtPointer cl,cd;
 { set_and_draw_srand(); world_reset(); }
static void QuitCB(w,cl,cd) Widget w; XtPointer cl,cd;
 { movie_close(); exit(0); }
static void RunCB(w,cl,cd) Widget w; XtPointer cl,cd; { progress(PMRun); }
static void GenerationCB(w,cl,cd) Widget w; XtPointer cl,cd;
 { progress(PMOneGeneration); }
static void StepCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	if (Step >= GenerationLength) selection();
	else exec_one_step();
	set_pmode(PMStop);
}
static void MotionCB(w,cl,cd) Widget w; XtPointer cl,cd;
 { MotionCount = 0; progress(PMMotion); }
static Widget	DurationText = NULL;
static void DurationOK(w,cl,cd) Widget w; XtPointer cl,cd; {
	char	*vstr;
	XtVaGetValues(DurationText,XmNvalue,&vstr,NULL);
	MotionDuration = atoi(vstr);
}
static void SetDurationCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	static	Widget	Dialog = NULL;
	static	char	buf[16];
	if (!Dialog) {
		Dialog = XmCreateQuestionDialog(w,"MotionDurationQuery",
			ShellArgs,NShellArg);
		XtUnmanageChild(XmMessageBoxGetChild(Dialog,XmDIALOG_HELP_BUTTON));
		XtManageChild(DurationText=XmCreateText(Dialog,"DurationText",
			NULL,0));
		XtAddCallback(Dialog,XmNokCallback,DurationOK,NULL);
	}
	sprintf(buf,"%d",MotionDuration);
	XtVaSetValues(DurationText,XmNvalue,buf,NULL);
	XtManageChild(Dialog);
}
static void BackCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	Generation --; new_generation();
}
static void StopCB(w,cl,cd) Widget w; XtPointer cl,cd; { set_pmode(PMStop); }
static void StopDeluxe() {
	if (DrawShape == DrSpDeluxe) {
		DrawShape = DrSpGrowingSpheres;
		XtVaSetValues(GrowingSpheresButton,XmNset,True,NULL);
		XtVaSetValues(DeluxeButton,XmNset,False,NULL);
	}
}
struct scale_value {
	double *var; char *name; int min, max;
	double bias, dflt; Widget scale; };
static void ThetaCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	struct scale_value *sv = (struct scale_value *)cl;
	XmScaleCallbackStruct *sc = (XmScaleCallbackStruct *)cd;
	*(sv->var) = sc->value / sv->bias;
	StopDeluxe(); redraw_world();
}
static void ParamCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	struct scale_value *sv = (struct scale_value *)cl;
	XmScaleCallbackStruct *sc = (XmScaleCallbackStruct *)cd;
	*(sv->var) = sc->value / sv->bias;
}
static void set_param_scale(parent,sv,args,m,proc)
Widget parent; struct scale_value *sv; Arg *args; int m; void (*proc)();
{
	int	n;
	Widget	scale;
	XmString	str;
	for (; sv->var; sv ++) {
		str = XmStringCreateSimple(sv->name);
		n = m;
		XtSetArg(args[n],XmNvalue,(int)(*(sv->var)*sv->bias)); n ++;
		XtSetArg(args[n],XmNtitleString,str); n ++;
		XtSetArg(args[n],XmNmaximum,sv->max); n ++;
		XtSetArg(args[n],XmNminimum,sv->min); n ++;
		XtManageChild(scale=XmCreateScale(parent,sv->name,args,n));
		XtAddCallback(scale,XmNdragCallback,proc,sv);
		XtAddCallback(scale,XmNvalueChangedCallback,proc,sv);
		XmStringFree(str);
		sv->scale = scale;
	}
}
static void DefaultCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	struct scale_value *pp, *sv = (struct scale_value *)cl;
	for (pp = sv; pp->var; pp ++) {
		*(pp->var) = pp->dflt;
		XtVaSetValues(pp->scale,XmNvalue,(int)(pp->dflt*pp->bias),
			NULL);
	}
	if (sv->var == &RotateX) { StopDeluxe(); redraw_world(); }
}
static void setup_param_dialog_buttons(Dialog,sv)
Widget Dialog; struct scale_value *sv;
{
	static XmString str = NULL;
	if (!str) str = XmStringCreateSimple("Default");
	XtVaSetValues(Dialog,XmNhelpLabelString,str,NULL);
	XtUnmanageChild(XmMessageBoxGetChild(Dialog,XmDIALOG_CANCEL_BUTTON));
	XtAddCallback(Dialog,XmNhelpCallback,DefaultCB,sv);
}
static void MetabolismCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	static	Widget	Dialog = NULL;
	Widget	box;
	int	n;
	Arg	args[8];
	extern	double	MoveNut, IncNut, ThGlucose, ThH2O, DryAway;
	static	struct scale_value *pp, sv[] = {
		{&MoveNut,"Diffusion",0,100,100.},
		{&IncNut,"Feeding",0,100,100.},
		{&ThGlucose,"ThGlucose",0,100,100.},{&ThH2O,"ThH2O",0,100,100.},
		{&DryAway,"Dry",0,100,100.},{NULL}};
	if (!Dialog) {
		for (pp = sv; pp->var; pp ++)
			{ pp->dflt = *(pp->var); pp->bias = 100.; }
		Dialog = XmCreateQuestionDialog(w,"MetabolismQuery",
			ShellArgs,NShellArg);
		setup_param_dialog_buttons(Dialog,sv);
		XtManageChild(box=XmCreateRowColumn(Dialog,"MetaboBox",NULL,0));
		n = 0; XtSetArg(args[n],XmNorientation,XmHORIZONTAL); n ++;
		XtSetArg(args[n],XmNshowValue,True); n ++;
		XtSetArg(args[n],XmNdecimalPoints,2); n ++;
		XtSetArg(args[n],XmNscaleWidth,300); n ++;
		set_param_scale(box,sv,args,n,ParamCB);
	}
	XtManageChild(Dialog);
}
static	struct scale_value ViewSV[] = {
	{&RotateX,"ThetaX",-180,179,180./M_PI},
	{&RotateY,"ThetaY",-180,179,180./M_PI},
	{&RotateZ,"ThetaZ",-180,179,180./M_PI},
	{&ViewDistance,"Distance",0,200,10.},
	{&ViewShift,"Shift",-200,199,100.},
	{&ViewHeight,"Height",-200,199,100.},
	{&ScaleR,"ScaleR",1,50,10.},{NULL}
};
static	Widget	ViewpointDialog = NULL;
static void adjust_viewpoint_scales()
{
	struct scale_value	*pp;
	int	new, old;
	for (pp = ViewSV; pp->var; pp ++) {
		new = (int)(*(pp->var) * pp->bias);
		XtVaGetValues(pp->scale,XmNvalue,&old,NULL);
		if (new != old) XtVaSetValues(pp->scale,XmNvalue,new,NULL);
	}
}
static void viewpoint_scale_init()
{
	struct scale_value *pp;
	for (pp = ViewSV; pp->var; pp ++) pp->dflt = *(pp->var);
}
static void ViewpointCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	Widget	box;
	int	n;
	Arg	args[8];
	if (!ViewpointDialog) {
		ViewpointDialog = XmCreateQuestionDialog(w,"ViewpointQuery",
			ShellArgs,NShellArg);
		setup_param_dialog_buttons(ViewpointDialog,ViewSV);
		box = XmCreateRowColumn(ViewpointDialog,"ViewBox",NULL,0);
		XtManageChild(box);
		n = 0; XtSetArg(args[n],XmNorientation,XmHORIZONTAL); n ++;
		XtSetArg(args[n],XmNshowValue,True); n ++;
		XtSetArg(args[n],XmNscaleWidth,380); n ++;
		set_param_scale(box,ViewSV,args,n,ThetaCB);
	} else	adjust_viewpoint_scales();
	XtManageChild(ViewpointDialog);
}
static void ViewMotionCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	static	Widget	Dialog = NULL;
	Widget	box;
	int	n;
	Arg	args[8];
	struct scale_value	*pp;
	static	struct scale_value	sv[] = {
		{&RotateXV,"OmegaX",-180,179,1800./M_PI},
		{&RotateYV,"OmegaY",-180,179,1800./M_PI},
		{&RotateZV,"OmegaZ",-180,179,1800./M_PI},
		{&DistanceV,"Distance",-100,99,100.},
		{&ScaleRV,"ScaleR",90,109,100.},{NULL}};
	if (!Dialog) {
		for (pp = sv; pp->var; pp ++) pp->dflt = *(pp->var);
		Dialog = XmCreateQuestionDialog(w,"ViewMotionQuery",
			ShellArgs,NShellArg);
		setup_param_dialog_buttons(Dialog,sv);
		XtManageChild(box=XmCreateRowColumn(Dialog,"ViewBox",NULL,0));
		n = 0; XtSetArg(args[n],XmNorientation,XmHORIZONTAL); n ++;
		XtSetArg(args[n],XmNshowValue,True); n ++;
		XtSetArg(args[n],XmNdecimalPoints,1); n ++;
		XtSetArg(args[n],XmNscaleWidth,300); n ++;
		set_param_scale(box,sv,args,n,ParamCB);
	}
	XtManageChild(Dialog);
}
static void DrawModeCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	static	Widget	Dialog = NULL;
	Widget	box, menu, button;
	int	n;
	Arg	args[8];
	if (!Dialog) {
	Dialog = XmCreateQuestionDialog(w,"DrawingModeQuery",
		ShellArgs,NShellArg);
	XtUnmanageChild(XmMessageBoxGetChild(Dialog,XmDIALOG_CANCEL_BUTTON));
	XtUnmanageChild(XmMessageBoxGetChild(Dialog,XmDIALOG_HELP_BUTTON));
	XtSetArg(args[0],XmNorientation,XmHORIZONTAL);
	XtManageChild(box=XmCreateRowColumn(Dialog,"DrawMenuBox",args,1));
	XtSetArg(args[0],XmNradioBehavior,True);
	XtManageChild(menu=XmCreateRowColumn(box,"ShapeMenu",args,1));
	XtManageChild(XmCreateLabel(menu,"Shape",NULL,0));
	XtSetArg(args[0],XmNset,True);
	XtManageChild(button=XmCreateToggleButton(menu,"Spheres",args,0));
	XtAddCallback(button,XmNvalueChangedCallback,
		ShowModeCB,(XtPointer)DrSpSpheres);
	XtManageChild(GrowingSpheresButton=XmCreateToggleButton(menu,
		"Growing spheres",args,0));
	XtAddCallback(GrowingSpheresButton,XmNvalueChangedCallback,
		ShowModeCB,(XtPointer)DrSpGrowingSpheres);
	XtManageChild(button=XmCreateToggleButton(menu,"Skeleton",args,1));
	XtAddCallback(button,XmNvalueChangedCallback,
		ShowModeCB,(XtPointer)DrSpSkeleton);
	if (visual.class == TrueColor) {
		DeluxeButton = XmCreateToggleButton(menu,"Deluxe",NULL,0);
		XtManageChild(DeluxeButton);
		XtAddCallback(DeluxeButton,XmNvalueChangedCallback,
			ShowModeCB,(XtPointer)DrSpDeluxe);
	}
	XtSetArg(args[0],XmNradioBehavior,True);
	XtManageChild(menu=XmCreateRowColumn(box,"DrawWhatMenu",args,1));
	XtManageChild(XmCreateLabel(menu,"What?",NULL,0));
	XtSetArg(args[0],XmNset,True);
	XtManageChild(button=XmCreateToggleButton(menu,"Everything",args,1));
	XtAddCallback(button,XmNvalueChangedCallback,DrawWhatCB,(XtPointer)(-1));
	XtManageChild(button=XmCreateToggleButton(menu,"Best 9",NULL,0));
	XtAddCallback(button,XmNvalueChangedCallback,DrawWhatCB,(XtPointer)9);
	XtManageChild(button=XmCreateToggleButton(menu,"Nothing",NULL,0));
	XtAddCallback(button,XmNvalueChangedCallback,DrawWhatCB,(XtPointer)0);
	XtSetArg(args[0],XmNradioBehavior,True);
	XtManageChild(menu=XmCreateRowColumn(box,"DrawWhenMenu",args,1));
	XtManageChild(XmCreateLabel(menu,"When?",NULL,0));
	XtSetArg(args[0],XmNset,True);
	XtManageChild(button=XmCreateToggleButton(menu,"Every step",args,0));
	XtAddCallback(button,XmNvalueChangedCallback,DrawWhenCB,(XtPointer)1);
	XtManageChild(button=XmCreateToggleButton(menu,"Every two steps",args,0));
	XtAddCallback(button,XmNvalueChangedCallback,DrawWhenCB,(XtPointer)2);
	XtManageChild(button=XmCreateToggleButton(menu,"Every five steps",args,0));
	XtAddCallback(button,XmNvalueChangedCallback,DrawWhenCB,(XtPointer)5);
	XtManageChild(button=XmCreateToggleButton(menu,"Every ten steps",args,1));
	XtAddCallback(button,XmNvalueChangedCallback,DrawWhenCB,(XtPointer)10);
	XtManageChild(button=XmCreateToggleButton(menu,"Only full size",args,0));
	XtAddCallback(button,XmNvalueChangedCallback,DrawWhenCB,(XtPointer)0);
	}
	XtManageChild(Dialog);
}
get_caption_string(str,font,x,y,align)
char	**str;
XFontStruct	**font;
int	*x, *y, *align;
{
	if (CaptionText) get_text(CaptionText,str,font,x,y,align);
	else *str = NULL;
	return 0;
}
static char	*CaptionInfo[] = {
"CaptionQuery",				/* widget name */
"Help message for Caption setting",	/* help message */
"Any character is drawn in zoomed window\n\
except special character \"%\" which is\n\
replaced by the current value of parameter\n\
as follows;\n\
%g = generation\n%s = steps\n%c = size (the number of cells)"};

static void CaptionCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	static	Widget	Dialog = NULL;
	Widget	CreateTextInputDialog();
	if (!Dialog) Dialog = CreateTextInputDialog(w,CaptionInfo,&CaptionText);
	XtManageChild(Dialog);
}
static void EvolutionCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	static	Widget	Dialog = NULL;
	Widget	frame, box, button, scale;
	XmString	title;
	int	n;
	Arg	args[8];
	if (!Dialog) {
	Dialog = XmCreateQuestionDialog(w,"EvolutionQuery",
		ShellArgs,NShellArg);
	XtUnmanageChild(XmMessageBoxGetChild(Dialog,XmDIALOG_CANCEL_BUTTON));
	XtUnmanageChild(XmMessageBoxGetChild(Dialog,XmDIALOG_HELP_BUTTON));
	n = 0; XtSetArg(args[n],XmNorientation,XmHORIZONTAL); n ++;
	XtManageChild(frame=XmCreateRowColumn(Dialog,"DrawMenus",args,n));
	n = 0; XtSetArg(args[n],XmNradioBehavior,True); n ++;
	XtSetArg(args[n],XmNmarginHeight,0); n ++;
	XtSetArg(args[n],XmNmarginWidth,0); n ++;
	XtManageChild(box=XmCreateRowColumn(frame,"SelectionMenu",args,n));
	XtManageChild(XmCreateLabel(box,"Selection",NULL,0));
	XtSetArg(args[0],XmNset,True);
	XtManageChild(button=XmCreateToggleButton(box,"Global 1/3",args,1));
	XtAddCallback(button,XmNvalueChangedCallback,
		SelModeCB,(XtPointer)SelGlobal3rd);
	XtManageChild(button=XmCreateToggleButton(box,"Local 1/3",args,0));
	XtAddCallback(button,XmNvalueChangedCallback,
		SelModeCB,(XtPointer)SelLocal3rd);
	XtManageChild(button=XmCreateToggleButton(box,"Local C&M",args,0));
	XtAddCallback(button,XmNvalueChangedCallback,
		SelModeCB,(XtPointer)SelLocalSel);
	XtSetArg(args[0],XmNradioBehavior,True);
	XtManageChild(box=XmCreateRowColumn(frame,"CrossoverMenu",args,n));
	XtManageChild(XmCreateLabel(box,"Crossover",NULL,0));
	XtSetArg(args[0],XmNset,True);
	XtManageChild(button=XmCreateToggleButton(box,"One point",args,1));
	XtAddCallback(button,XmNvalueChangedCallback,
		CrossoverCB,(XtPointer)CrsOnePoint);
	XtManageChild(button=XmCreateToggleButton(box,"Two points",args,0));
	XtAddCallback(button,XmNvalueChangedCallback,
		CrossoverCB,(XtPointer)CrsTwoPoints);
	XtManageChild(button=XmCreateToggleButton(box,"Uniform",args,0));
	XtAddCallback(button,XmNvalueChangedCallback,
		CrossoverCB,(XtPointer)CrsUniform);
	title = XmStringCreateSimple("Mutation rate");
	n = 0; XtSetArg(args[n],XmNtitleString,title); n ++;
	XtSetArg(args[n],XmNorientation,XmHORIZONTAL); n ++;
	XtSetArg(args[n],XmNscaleWidth,220); n ++;
	XtSetArg(args[n],XmNvalue,(int)(MutationRate*1000)); n ++;
	XtSetArg(args[n],XmNshowValue,True); n ++;
	XtSetArg(args[n],XmNmaximum,200); n ++;
	XtSetArg(args[n],XmNdecimalPoints,3); n ++;
	XtManageChild(scale=XmCreateScale(frame,"MutationRate",args,n));
	XtAddCallback(scale,XmNvalueChangedCallback,MutationCB,NULL);
	XmStringFree(title);
	}
	XtManageChild(Dialog);
}
static void SeedOK(w,cl,cd) Widget w; XtPointer cl,cd; {
	char	*vstr;
	XtVaGetValues(SeedText,XmNvalue,&vstr,NULL);
	SeedForRandom = atoi(vstr);
	set_and_draw_srand();
}
static void SeedCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	static	Widget	Dialog = NULL;
	if (!Dialog) {
		Dialog = XmCreateQuestionDialog(w,"SeedQuery",
			ShellArgs,NShellArg);
		XtUnmanageChild(XmMessageBoxGetChild(Dialog,XmDIALOG_HELP_BUTTON));
		XtManageChild(SeedText=XmCreateText(Dialog,"SeedText",NULL,0));
		XtAddCallback(Dialog,XmNokCallback,SeedOK,NULL);
	}
	XtManageChild(Dialog);
}
static void StepsOK(w,cl,cd) Widget w; XtPointer cl,cd; {
	int	val;
	char	*vstr;
	XtVaGetValues((Widget)cl,XmNvalue,&vstr,NULL);
	if ((val = atoi(vstr)) > 0) GenerationLength = val;
}
static void StepsCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	static	Widget	Dialog = NULL; Widget text;
	if (!Dialog) {
		Dialog = XmCreateQuestionDialog(w,"StepsQuery",
			ShellArgs,NShellArg);
		XtUnmanageChild(XmMessageBoxGetChild(Dialog,XmDIALOG_HELP_BUTTON));
		XtManageChild(text=XmCreateText(Dialog,"StepsText",NULL,0));
		XtAddCallback(Dialog,XmNokCallback,StepsOK,(XtPointer)text);
	}
	XtManageChild(Dialog);
}
static void GenomeGraphCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	if (((XmToggleButtonCallbackStruct *)cd)->set) {
		if (!viewg_on(NULL))
			XtVaSetValues(GenomeGraphButton,XmNset,False,NULL);
	} else viewg_off();
}
static void EvoProcCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	if (((XmToggleButtonCallbackStruct *)cd)->set) {
		if (!viewe_on())
			XtVaSetValues(EvolutionProcessButton,XmNset,False,NULL);
	} else viewe_off();
}
static char	*helpMessage = "How to use l3m";
static char	*helpText = "\
Mouse operation:\n\
  Left button   = switches zoom mode on/off.\n\
  Middle button = shows state transition diagram\n\
                  of development rule set.\n\
  Right button  = outputs individual information\n\
                  to standard output device of Unix.";
static void helpCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	static Widget	helpDialog = NULL;
	if (!helpDialog) createHelpDialog(w,helpMessage,helpText,&helpDialog);
	XtManageChild(helpDialog);
}
static void ClickCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	XmDrawingAreaCallbackStruct *d = (XmDrawingAreaCallbackStruct *)cd;
	if (d->event->type != ButtonPress) return;
	switch (d->event->xbutton.button) {
		case Button1:
		switch_draw_mode(d->event->xbutton.x,d->event->xbutton.y);
		break;
		case Button2:
		show_gene(d->event->xbutton.x,d->event->xbutton.y); break;
		case Button3:
		show_individual(d->event->xbutton.x,d->event->xbutton.y);
	}
}
static void RedrawCB(w,cl,cd) Widget w; XtPointer cl,cd; {
	XCopyArea(dpy,pixmap,window,gc,0,0,WindowWidth,WindowHeight,0,0);
}
static	Pixmap	PixG, PixS, PixF;
static Pixmap set_num_pixmap(w) Widget w;
{
	Pixmap pmap = XCreatePixmap(dpy,XtWindow(w),WinWidth,WinHeight,depth);
	XSetForeground(dpy,gc,Winbg);
	XFillRectangle(dpy,pmap,gc,0,0,WinWidth,WinHeight);
	XtVaSetValues(w,XmNlabelType,XmPIXMAP,XmNlabelPixmap,pmap,NULL);
	return pmap;
}

#include	"icon.xpm"

gr_init(argc,argv) int argc; char *argv[];
{
	Widget	main_win, menu_bar, menu, submenu, button, panel, draw;
	Widget	win_g, win_s, win_f;
	XmFontList	fontList;
	XmFontContext	context;
	XmStringCharSet	charset;
	Dimension	w, h;
	XGCValues	xgcv;
	Pixmap	icon;
	int	scr, i, n;
	Arg	args[5];
	extern	char *fallback_resources[];
	XVisualInfo	*v, *vmax, Vinfo;
	XtToolkitInitialize();
	app_con = XtCreateApplicationContext();
	XtAppSetFallbackResources(app_con,fallback_resources);
	dpy = XtOpenDisplay(app_con,NULL,NULL,"L3m",NULL,0,&argc,argv);
	if (!dpy) {
		fprintf(stderr,"%s cannot open display.\n",argv[0]);
		exit(1);
	}
	Vinfo.class = TrueColor;
	v = XGetVisualInfo(dpy,VisualClassMask,&Vinfo,&n);
	for (vmax = v, i = 1; i < n; i ++)
		if (vmax->depth < v[i].depth) vmax = v + i;
	if (!v || v->depth < 12) {
		Vinfo.class = PseudoColor;
		if (!(v = XGetVisualInfo(dpy,VisualClassMask,&Vinfo,&n))) {
fprintf(stderr,"%s seems not to support color display.\n",XDisplayName(NULL));
			exit(1);
		}
	}
	visual = *(vmax->visual);
	depth = vmax->depth;
	scr = DefaultScreen(dpy);
	cmap = XCreateColormap(dpy,DefaultRootWindow(dpy),&visual,AllocNone);
	NShellArg = 0;
	XtSetArg(ShellArgs[NShellArg],XtNcolormap,cmap); NShellArg ++;
	XtSetArg(ShellArgs[NShellArg],XtNvisual,&visual); NShellArg ++;
	XtSetArg(ShellArgs[NShellArg],XtNdepth,depth); NShellArg ++;
	if (XpmCreatePixmapFromData(dpy,DefaultRootWindow(dpy),icon_xpm,
		&icon,NULL,NULL) == XpmSuccess) {
		XtSetArg(ShellArgs[NShellArg],XtNiconPixmap,icon);
		NShellArg ++;
	}
	app_sh = XtAppCreateShell(NULL,NULL,applicationShellWidgetClass,
		dpy,ShellArgs,NShellArg);
	XtManageChild(main_win=XmCreateMainWindow(app_sh,"main_window",NULL,0));
	XtManageChild(menu_bar=XmCreateMenuBar(main_win,"menu_bar",NULL,0));
	menu = XmCreatePulldownMenu(menu_bar,"FileMenu",ShellArgs,NShellArg);
	XtManageChild(button=XmCreatePushButton(menu,"Open",NULL,0));
	XtAddCallback(button,XmNactivateCallback,OpenCB,NULL);
	XtManageChild(button=XmCreatePushButton(menu,"Load",NULL,0));
	XtAddCallback(button,XmNactivateCallback,LoadCB,NULL);
	XtManageChild(button=XmCreatePushButton(menu,"Save",NULL,0));
	XtAddCallback(button,XmNactivateCallback,SaveCB,NULL);
	XtManageChild(button=XmCreatePushButton(menu,"Save as ...",NULL,0));
	XtAddCallback(button,XmNactivateCallback,SaveAsCB,NULL);
	XtManageChild(XmCreateSeparator(menu,"Sep1",NULL,0));
	XtManageChild(button=XmCreatePushButton(menu,"Print",NULL,0));
	XtAddCallback(button,XmNactivateCallback,PrintCB,NULL);
	XtManageChild(button=XmCreatePushButton(menu,"Save image",NULL,0));
	XtAddCallback(button,XmNactivateCallback,SaveImgCB,NULL);
	submenu = XmCreatePulldownMenu(menu,"MovieRecMenu",ShellArgs,NShellArg);
	XtManageChild(button=XmCreatePushButton(submenu,"Start new",NULL,0));
	XtAddCallback(button,XmNactivateCallback,StartNewMovieCB,NULL);
	XtSetArg(args[0],XmNsensitive,False);
	RestartMovieButton = XmCreatePushButton(submenu,"Restart",args,1);
	XtAddCallback(RestartMovieButton,XmNactivateCallback,RestartMovieCB,NULL);
	XtManageChild(RestartMovieButton);
	StopMovieButton = XmCreatePushButton(submenu,"Stop",args,1);
	XtAddCallback(StopMovieButton,XmNactivateCallback,StopMovieCB,NULL);
	XtManageChild(StopMovieButton);
	CloseMovieButton = XmCreatePushButton(submenu,"Close",args,1);
	XtAddCallback(CloseMovieButton,XmNactivateCallback,CloseMovieCB,NULL);
	XtManageChild(CloseMovieButton);
	XtSetArg(args[0],XmNsubMenuId,submenu);
	XtManageChild(button=XmCreateCascadeButton(menu,"QT Movie rec.",args,1));
	XtManageChild(button=XmCreatePushButton(menu,"Quit",NULL,0));
	XtAddCallback(button,XmNactivateCallback,QuitCB,NULL);
	XtSetArg(args[0],XmNsubMenuId,menu);
	XtManageChild(XmCreateCascadeButton(menu_bar,"File",args,1));
	XtSetArg(ShellArgs[NShellArg],XmNtearOffModel,XmTEAR_OFF_ENABLED);
	menu = XmCreatePulldownMenu(menu_bar,"ExecMenu",ShellArgs,NShellArg+1);
	XtManageChild(button=XmCreatePushButton(menu,"Run",NULL,0));
	XtAddCallback(button,XmNactivateCallback,RunCB,NULL);
	XtManageChild(button=XmCreatePushButton(menu,"One generation",NULL,0));
	XtAddCallback(button,XmNactivateCallback,GenerationCB,NULL);
	XtManageChild(button=XmCreatePushButton(menu,"Step",NULL,0));
	XtAddCallback(button,XmNactivateCallback,StepCB,NULL);
	submenu = XmCreatePulldownMenu(menu,"MotionMenu",ShellArgs,NShellArg);
	XtManageChild(button=XmCreatePushButton(submenu,"Motion start",NULL,0));
	XtAddCallback(button,XmNactivateCallback,MotionCB,NULL);
	XtManageChild(button=XmCreatePushButton(submenu,"Set duration",NULL,0));
	XtAddCallback(button,XmNactivateCallback,SetDurationCB,NULL);
	XtSetArg(args[0],XmNsubMenuId,submenu);
	XtManageChild(button=XmCreateCascadeButton(menu,"Motion",args,1));
	XtManageChild(button=XmCreatePushButton(menu,"Back to step 0",NULL,0));
	XtAddCallback(button,XmNactivateCallback,BackCB,NULL);
	XtManageChild(button=XmCreatePushButton(menu,"Restart",NULL,0));
	XtAddCallback(button,XmNactivateCallback,RestartCB,NULL);
	XtSetArg(args[0],XmNsubMenuId,menu);
	XtManageChild(XmCreateCascadeButton(menu_bar,"Exec",args,1));
	menu = XmCreatePulldownMenu(menu_bar,"ParameterMenu",
		ShellArgs,NShellArg);
	XtManageChild(button=XmCreatePushButton(menu,"Drawing",NULL,0));
	XtAddCallback(button,XmNactivateCallback,DrawModeCB,NULL);
	XtManageChild(button=XmCreatePushButton(menu,"Viewpoint",NULL,0));
	XtAddCallback(button,XmNactivateCallback,ViewpointCB,NULL);
	XtManageChild(button=XmCreatePushButton(menu,"View motion",NULL,0));
	XtAddCallback(button,XmNactivateCallback,ViewMotionCB,NULL);
	XtManageChild(button=XmCreatePushButton(menu,"Caption",NULL,0));
	XtAddCallback(button,XmNactivateCallback,CaptionCB,NULL);
	XtManageChild(XmCreateSeparator(menu,"ParaSep1",NULL,0));
	XtManageChild(button=XmCreatePushButton(menu,"Metabolism",NULL,0));
	XtAddCallback(button,XmNactivateCallback,MetabolismCB,NULL);
	XtManageChild(button=XmCreatePushButton(menu,"Evolution",NULL,0));
	XtAddCallback(button,XmNactivateCallback,EvolutionCB,NULL);
	XtManageChild(button=XmCreatePushButton(menu,"Seed",NULL,0));
	XtAddCallback(button,XmNactivateCallback,SeedCB,NULL);
	XtManageChild(button=XmCreatePushButton(menu,"Steps/Generation",NULL,0));
	XtAddCallback(button,XmNactivateCallback,StepsCB,NULL);
	XtSetArg(args[0],XmNsubMenuId,menu);
	XtManageChild(XmCreateCascadeButton(menu_bar,"Parameter",args,1));
	menu = XmCreatePulldownMenu(menu_bar,"WindowMenu",ShellArgs,NShellArg);
	button = XmCreateToggleButton(menu,"Genome graph",NULL,0);
	XtAddCallback(button,XmNvalueChangedCallback,GenomeGraphCB,NULL);
	XtManageChild(GenomeGraphButton = button);
	button = XmCreateToggleButton(menu,"Evolution process",NULL,0);
	XtAddCallback(button,XmNvalueChangedCallback,EvoProcCB,NULL);
	XtManageChild(EvolutionProcessButton = button);
	XtSetArg(args[0],XmNsubMenuId,menu);
	XtManageChild(XmCreateCascadeButton(menu_bar,"Window",args,1));
	XtSetArg(args[0],XmNsensitive,False);
	XtManageChild(StopButton=XmCreateCascadeButton(menu_bar,"Stop",args,1));
	XtAddCallback(StopButton,XmNactivateCallback,StopCB,NULL);
	XtManageChild(button=XmCreateCascadeButton(menu_bar,"Help",NULL,0));
	XtAddCallback(button,XmNactivateCallback,helpCB,NULL);
	XtVaSetValues(menu_bar,XmNmenuHelpWidget,button,NULL);
	n = 0; XtSetArg(args[n],XmNorientation,XmHORIZONTAL); n ++;
	XtManageChild(panel=XmCreateRowColumn(main_win,"panel",args,n));
	XtManageChild(XmCreateLabel(panel,"Generation",NULL,0));
	XtManageChild(win_g=XmCreateLabel(panel,"99999",NULL,0));
	XtManageChild(XmCreateLabel(panel,"Step",NULL,0));
	XtManageChild(win_s=XmCreateLabel(panel,"99999",NULL,0));
	XtManageChild(XmCreateLabel(panel,"Best",NULL,0));
	XtManageChild(win_f=XmCreateLabel(panel,"99999",NULL,0));
	XtManageChild(XmCreateLabel(panel,"Seed",NULL,0));
	XtManageChild(SeedRand=XmCreateLabel(panel,"99999",NULL,0));
	set_and_draw_srand();
	XtManageChild(draw=XmCreateDrawingArea(main_win,"field",NULL,0));
	XtVaSetValues(main_win,XmNshowSeparator,True,
		XmNcommandWindow,panel,XmNworkWindow,draw,NULL);
	XtRealizeWidget(app_sh);
	window = XtWindow(draw);
	WinG = XtWindow(win_g); WinS = XtWindow(win_s); WinF = XtWindow(win_f);
	XtVaGetValues(win_g,XmNwidth,&w,XmNheight,&h,XmNfontList,&fontList,
		XmNforeground,&Winfg,XmNbackground,&Winbg,NULL);
	WinWidth = w; WinHeight = h;
	XmFontListInitFontContext(&context, fontList);
	XmFontListGetNextFont(context, &charset, &Gfont);
	ShowNBase = (WinHeight -
	 Gfont->max_bounds.descent - Gfont->max_bounds.ascent) / 2
	 + Gfont->max_bounds.ascent;
	XtVaGetValues(draw,XmNwidth,&w,XmNheight,&h,
		XmNforeground,&fg,XmNbackground,&bg,NULL);
	WindowWidth = w; WindowHeight = h;
	pixmap = XCreatePixmap(dpy,window,WindowWidth,WindowHeight,depth);
	xgcv.font = Gfont->fid;
	xgcv.foreground = bg; xgcv.background = Winbg;
	gc = XtGetGC(draw,GCFont|GCForeground|GCBackground,&xgcv);
	XFillRectangle(dpy,pixmap,gc,0,0,WindowWidth,WindowHeight);
	PixG = set_num_pixmap(win_g);
	PixS = set_num_pixmap(win_s);
	PixF = set_num_pixmap(win_f);
	draw_init();
	viewpoint_scale_init();
	XtAddCallback(draw,XmNinputCallback,ClickCB,NULL);
	XtAddCallback(draw,XmNexposeCallback,RedrawCB,NULL);
}
event_loop() { XtAppMainLoop(app_con); }

static void draw_num(n,win,pmap) unsigned long n; Window win; Pixmap pmap;
{
	char	buf[32];
	sprintf(buf,"%-5d",n);
	XDrawImageString(dpy,pmap,gc,2,ShowNBase,buf,strlen(buf));
	XDrawImageString(dpy,win,gc,2,ShowNBase,buf,strlen(buf));
}
draw_info()
{
	static unsigned long	oldG = 99999, oldB = 99999;
	extern unsigned long	Generation, Step, BestScore;
	XSetForeground(dpy,gc,Winfg);
	if (oldG != Generation)
		{ draw_num(Generation,WinG,PixG); oldG = Generation; }
	if (DrawPopSize) draw_num(Step,WinS,PixS);
	if (oldB != BestScore)
		{ draw_num(BestScore,WinF,PixF); oldB = BestScore; }
}
static void move_theta(val,delta) double *val, delta;
{
	*val += delta;
	if (*val < -M_PI) *val += 2*M_PI;
	else if (*val > M_PI) *val -= 2*M_PI;
}
move_view_point()
{
	move_theta(&RotateX,RotateXV);
	move_theta(&RotateY,RotateYV);
	move_theta(&RotateZ,RotateZV);
	ViewDistance += DistanceV;
	if (ViewDistance < 0.) ViewDistance = 0;
	else if (ViewDistance > 20.) ViewDistance = 20.;
	ScaleR *= ScaleRV;
	if (ScaleR < .1) ScaleR = .1;
	else if (ScaleR > 5.) ScaleR = 5.;
	if (ViewpointDialog) if (XtIsManaged(ViewpointDialog))
		adjust_viewpoint_scales();
}
