#include	<stdio.h>

static	int	Speed = 30, Frames = 0, Width = 0, Height;
static	FILE	*out;

static void set_32bit_int(buf,n)
char *buf; long n;
{
	buf[0] = n >> 24; buf[1] = (n >> 16) & 0xff;
	buf[2] = (n >> 8) & 0xff; buf[3] = n & 0xff;
}
static void set_16bit_int(buf,n)
char *buf; int	n;
{
	buf[0] = (n >> 8) & 0xff; buf[1] = n & 0xff;
}
static void set_matraix(b)
char	*b;
{
	set_32bit_int(b,0x10000); /* matrix A */
	set_32bit_int(b+16,0x10000); /* matrix D */
	set_32bit_int(b+32,0x40000000); /* matrix W */
}
static void write32int(n)
unsigned long	n;
{
	unsigned char	buf[4];
	set_32bit_int(buf,n);
	fwrite(buf,1,4,out);
}
static void write_atom_header(size,type)
long size; char *type;
{
	write32int(size);
	fputs(type,out);
}

#define	TIME_SCALE	600
#define	VIDEO_H_NAME	"Apple Video Media Handler"
#define	ALIAS_H_NAME	"Apple Alias Data Handler"
#define	SIZE_MOOV	(8+SIZE_MVHD+SIZE_TRAK)
#define	SIZE_MVHD	108
#define	SIZE_TRAK	(8+SIZE_TKHD+SIZE_EDTS+SIZE_MDIA)
#define	SIZE_TKHD	92
#define	SIZE_EDTS	(8+SIZE_ELST)
#define	SIZE_ELST	28
#define	SIZE_MDIA	(8+SIZE_MDHD+SIZE_HDLR(VIDEO_H_NAME)+SIZE_MINF)
#define	SIZE_MDHD	32
#define	SIZE_HDLR(s)	(8+25+strlen(s))
#define	SIZE_MINF	(8+SIZE_VMHD+SIZE_HDLR(ALIAS_H_NAME)+SIZE_DINF+SIZE_STBL)
#define	SIZE_VMHD	20
#define	SIZE_DINF	(8+SIZE_DREF)
#define	SIZE_DREF	28
#define	SIZE_STBL	(8+SIZE_STSD+SIZE_STTS+SIZE_STSC+SIZE_STSZ+SIZE_STCO)
#define	SIZE_STSD	102
#define	SIZE_STTS	24
#define	SIZE_STSC	(16+12*2)
#define	SIZE_STSZ	20
#define	SIZE_STCO	(16+Frames*4)
#define	SIZE_STRAK	(8+SIZE_TKHD+SIZE_EDTS+SIZE_SMDIA)
#define	SIZE_SMDIA	(8+SIZE_MDHD+SIZE_HDLR(AUDIO_H_NAME)+SIZE_SMINF)
#define	SIZE_SMINF	(8+SIZE_SMHD+SIZE_HDLR(ALIAS_H_NAME)+SIZE_DINF+SIZE_SSTBL)
#define	SIZE_SMHD	16
#define	SIZE_SSTBL	(8+SIZE_SSTSD+SIZE_STTS+SIZE_STSC+SIZE_STSZ+SIZE_STCO)
#define	SIZE_SSTSD	52

static void write_qt_rsrc()
{
	int	duration = Frames * TIME_SCALE / Speed;
	int	i;
	char	b[2048];
	write_atom_header(SIZE_MOOV,"moov");
	write_atom_header(SIZE_MVHD,"mvhd");	/* Movie Header */
	memset(b,0,SIZE_MVHD-8);
	set_32bit_int(b+12,TIME_SCALE);	/* time scale */
	set_32bit_int(b+16,duration);	/* duration */
	set_32bit_int(b+20,0x010000);	/* prefered rate (normal) */
	set_matraix(b+36);
	set_32bit_int(b+96,2);		/* next track ID */
	fwrite(b,1,SIZE_MVHD-8,out);
	write_atom_header(SIZE_TRAK,"trak");
	write_atom_header(SIZE_TKHD,"tkhd");	/* Track Header */
	memset(b,0,SIZE_TKHD-8);
	b[3] = 0x0f;				/* track header flags */
	set_32bit_int(b+12,1);			/* track ID */
	set_32bit_int(b+20,duration);		/* duration */
	set_matraix(b+40);
	set_16bit_int(b+76,Width);
	set_16bit_int(b+80,Height);
	fwrite(b,1,SIZE_TKHD-8,out);
	write_atom_header(SIZE_EDTS,"edts");	/* Edit */
	write_atom_header(SIZE_ELST,"elst");
	memset(b,0,SIZE_ELST-8);
	set_32bit_int(b+4,1);		/* number of entries */
	set_32bit_int(b+8,duration);	/* track duration */
	set_32bit_int(b+12,0);		/* media time */
	set_32bit_int(b+16,0x010000);	/* media rate */
	fwrite(b,1,SIZE_ELST-8,out);
	write_atom_header(SIZE_MDIA,"mdia");
	write_atom_header(SIZE_MDHD,"mdhd");	/* Media Header */
	memset(b,0,SIZE_MDHD-8);
	set_32bit_int(b+12,TIME_SCALE);	/* time scale */
	set_32bit_int(b+16,duration);	/* duration */
	fwrite(b,1,SIZE_MDHD-8,out);
	write_atom_header(SIZE_HDLR(VIDEO_H_NAME),"hdlr");
	memset(b,0,SIZE_HDLR(VIDEO_H_NAME)-8);
	memcpy(b+4,"mhlr",4);		/* component type */
	memcpy(b+8,"vide",4);		/* component subtype */
	b[24] = strlen(VIDEO_H_NAME);
	memcpy(b+25,VIDEO_H_NAME,strlen(VIDEO_H_NAME));	/* component name */
	fwrite(b,1,SIZE_HDLR(VIDEO_H_NAME)-8,out);
	write_atom_header(SIZE_MINF,"minf");
	write_atom_header(SIZE_VMHD,"vmhd");	/* Video Media Header */
	memset(b,0,SIZE_VMHD-8);
	b[3] = 0x01;			/* flag: No lean ahead */
	set_16bit_int(b+4,0x40);	/* graphics mode */
	set_16bit_int(b+6,0x8000);	/* opcolor red */
	set_16bit_int(b+8,0x8000);	/* opcolor green */
	set_16bit_int(b+10,0x8000);	/* opcolor blue */
	fwrite(b,1,SIZE_VMHD-8,out);
	write_atom_header(SIZE_HDLR(ALIAS_H_NAME),"hdlr");
	memset(b,0,SIZE_HDLR(ALIAS_H_NAME)-8);
	memcpy(b+4,"dhlr",4);		/* component type */
	memcpy(b+8,"alis",4);		/* component subtype */
	b[24] = strlen(ALIAS_H_NAME);
	memcpy(b+25,ALIAS_H_NAME,strlen(ALIAS_H_NAME));
	fwrite(b,1,SIZE_HDLR(ALIAS_H_NAME)-8,out);
	write_atom_header(SIZE_DINF,"dinf");
	write_atom_header(SIZE_DREF,"dref");	/* Data Reference */
	memset(b,0,SIZE_DREF-8);
	set_32bit_int(b+4,1);		/* number of entries */
	set_32bit_int(b+8,12);		/* size of data reference */
	memcpy(b+12,"alis",4);
	b[19] = 0x01;			/* self reference */
	fwrite(b,1,SIZE_DREF-8,out);
	write_atom_header(SIZE_STBL,"stbl");
	write_atom_header(SIZE_STSD,"stsd");	/* Sample Description */
	memset(b,0,SIZE_STSD-8);
	set_32bit_int(b+4,1);		/* number of entries */
	set_32bit_int(b+8,86);		/* sample description size */
	memcpy(b+12,"raw ",4);		/* data format */
	set_16bit_int(b+22,1);		/* data reference index */
	memcpy(b+28,"appl",4);		/* vender */
	set_32bit_int(b+32,1);		/* temporal quality */
	set_32bit_int(b+36,1);		/* spacial quality */
	set_16bit_int(b+40,Width);
	set_16bit_int(b+42,Height);
	set_32bit_int(b+44,0x480000);	/* horizontal resolution */
	set_32bit_int(b+48,0x480000);	/* vertical resolution */
	set_16bit_int(b+56,1);		/* frame count */
	set_16bit_int(b+90,24);		/* depth */
	set_16bit_int(b+92,-1);		/* Color table ID (default) */
	fwrite(b,1,SIZE_STSD-8,out);
	write_atom_header(SIZE_STTS,"stts");	/* Time to Sample */
	memset(b,0,SIZE_STTS-8);
	set_32bit_int(b+4,1);		/* number of entries */
	set_32bit_int(b+8,Frames);	/* sample count */
	set_32bit_int(b+12,duration/Frames);	/* sample duration */
	fwrite(b,1,SIZE_STTS-8,out);
	write_atom_header(SIZE_STSC,"stsc");	/* Sample to Chunk */
	memset(b,0,SIZE_STSC-8);
	set_32bit_int(b+4,2);		/* number of entries */
	set_32bit_int(b+8,1);		/* first chunk */
	set_32bit_int(b+12,1);		/* samples per chunk */
	set_32bit_int(b+16,1);		/* sample description ID */
	set_32bit_int(b+20,Frames);	/* final chunk */
	set_32bit_int(b+24,1);
	set_32bit_int(b+28,1);
	fwrite(b,1,SIZE_STSC-8,out);
	write_atom_header(SIZE_STSZ,"stsz");	/* Sample Size */
	memset(b,0,12);
	set_32bit_int(b+4,Width*Height*3);
	set_32bit_int(b+8,Frames);
	fwrite(b,1,12,out);
	write_atom_header(SIZE_STCO,"stco");	/* Chunk Offset */
	memset(b,0,8);
	set_32bit_int(b+4,Frames);	/* number of entries */
	fwrite(b,1,8,out);
	for (i = 0; i < Frames; i ++) write32int(i*Width*Height*3+8);
}

qt_init(fd,w,h)
FILE	*fd;
int	w, h;
{
	out = fd; Width = w; Height = h;
	write_atom_header(Width*Height*3*Frames+8,"mdat");
	return 0;
}

qt_close(fr)
int	fr;
{
	Frames = fr;
	rewind(out);
	write_atom_header(Width*Height*3*Frames+8,"mdat");
	fflush(out);
	fseek(out,0L,SEEK_END);
	write_qt_rsrc();
	fclose(out);
}
